=== debian/changelog ===
llvm-toolchain-snapshot (1:14~++20210731090915+593059b328cf-1~exp1build1) impish; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Sep 2021 06:17:12 +0200

llvm-toolchain-snapshot (1:14~++20210731090915+593059b328cf-1~exp1) unstable; urgency=medium

  * snapshot is now 14.
  * Merge the different recent changes from 12 & 12 (libunwind, 
    libclang, some libc++ options)
  * revert the s390 patch as it is probably fixed

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Jul 2021 09:42:50 +0200

llvm-toolchain-13 (1:13~++20210731010128+6eaf46beb462-1~exp1) experimental; urgency=medium

  * Branching of snapshot into 13
  * Adjust libclang:
    - upstream decided to make it stable starting from 13, with the soname
    - for now, I am not planning to rename libclang1-13 to libclang13 as it will
      cause too much churn for a small gain as we will keep libllvm (while
      losing the capability to have different versions in parallel installed)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Jul 2021 09:40:58 +0200

llvm-toolchain-snapshot (1:13~++20210720093711+b2e25572d2a7-1~exp1) UNRELEASED; urgency=medium

  * experimental New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Jul 2021 09:40:58 +0200

llvm-toolchain-snapshot (1:13~++20210715093511+afc760ef3527-1~exp1) experimental; urgency=medium

  * Refresh the lib of symbols in libomp
  * As scan-build-py is installed by default ( https://reviews.llvm.org/D104138 )
    update of the code
  * Revert "Revert D94333.diff as it breaks the ci
    https://reviews.llvm.org/D94333#2829043"
  * Install usr/lib/llvm-13/lib/cmake/openmp/FindOpenMPTarget.cmake
    in libomp-13-dev.install
  * Revert of D103865 for causing bug 51026

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 15 Jul 2021 21:46:58 +0200

llvm-toolchain-12 (1:12.0.1-2) unstable; urgency=medium

  * Generate libunwind-12 & libunwind-12-dev packages
  * Add the following option to the libc++ build:
    -DLIBCXX_ENABLE_STATIC_ABI_LIBRARY=ON
    -DLIBCXX_STATICALLY_LINK_ABI_IN_STATIC_LIBRARY=ON
    -DLIBCXX_STATICALLY_LINK_ABI_IN_SHARED_LIBRARY=OFF
     to address upstream bug 46321
  * Make libc++abi use libunwind

  [ Kasper Kantz ]
  * Add riscv64 architecture in control
    enable liblldb, libomp and others which are
    currently unavailable in riscv64 repository.

  [ Krzysztof Aleksander Pyrkosz ]
  * Add libxml2 as a dependency as it is necessary
    for llvm manifest tool (llvm-mt)
    (Closes: #990537)

  [ Jordan Justen ]
  * d/rules: Adjust cmake defines to fix libclc.pc paths
  * Add the following option to the libc++ build:
    -DLIBCXX_ENABLE_STATIC_ABI_LIBRARY=ON
    -DLIBCXX_STATICALLY_LINK_ABI_IN_STATIC_LIBRARY=ON
    -DLIBCXX_STATICALLY_LINK_ABI_IN_SHARED_LIBRARY=OFF
     to address upstream bug 46321
  * Build libunwind

  [ Kasper Kantz ]
  * Add riscv64 architecture in control
    enable liblldb, libomp and others which are
    currently unavailable in riscv64 repository.

  [ Krzysztof Aleksander Pyrkosz ]
  * Add libxml2 as a dependency as it is necessary
    for llvm manifest tool (llvm-mt)
    (Closes: #990537)

  [ Jordan Justen ]
  * d/rules: Adjust cmake defines to fix libclc.pc paths

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 12 Jul 2021 08:19:59 +0200

llvm-toolchain-12 (1:12.0.1-1) unstable; urgency=medium

  * New upsream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 09 Jul 2021 09:13:12 +0200

llvm-toolchain-12 (1:12.0.1~+rc4-1) unstable; urgency=medium

  * New testing upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 03 Jul 2021 00:17:36 +0200

llvm-toolchain-12 (1:12.0.1~+rc3-1) unstable; urgency=medium

  * New testing upstream release
  * Fix the path to analyze-{cc,c++} for scan-build-py with
    --intercept-first (scan-build-py-fix-analyze-path.diff)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 26 Jun 2021 10:00:56 +0200

llvm-toolchain-12 (1:12.0.1~+rc2-1) unstable; urgency=medium

  * New testing upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 21 Jun 2021 16:06:36 +0200

llvm-toolchain-12 (1:12.0.1~+rc1-1) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Add upstream patch D98574 to fix clang macro definitions on sparc64
  * Add upstream patch D98575 to fix 32-bit compiler-rt build on sparc64

  [ Sylvestre Ledru ]
  * backport D101773 to fix an llvm ir issue on mipsel
    in mips/mips-D101773-reloc.patch
    thanks to Ximin Luo
    (Closes: #988965)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 28 May 2021 23:27:27 +0200

llvm-toolchain-12 (1:12.0.1~+rc1-1~exp1) unstable; urgency=medium

  * New testing upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 26 May 2021 13:10:29 +0200

llvm-toolchain-12 (1:12.0.0-3) unstable; urgency=medium

  [ Timo Aaltonen ]
  * Build libclc. (Closes: #942709)

  [ Sylvestre Ledru ]
  * Upload to unstable
  * Also build lld on s390x

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 01 May 2021 19:33:27 +0200

llvm-toolchain-12 (1:12.0.0-2) experimental; urgency=medium

  [ Matthias Klose ]
  * Improve the clean rule
  * Disable again LTO
  * Create a new package llvm-12-linker-tools:
    Contains the LLVMgold and LLVMPolly linker plugins.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 15 Apr 2021 13:27:57 +0200

llvm-toolchain-11 (1:11.1.0-1~exp2) experimental; urgency=medium

  * Fix the default binary path for scan-build-py to clang-11 (instead of
    clang) - see scan-build-py-fix-default-bin.diff
    tested by
    https://github.com/opencollab/llvm-toolchain-integration-test-suite/

  [ Krzysztof Aleksander Pyrkosz ]
  * Add libxml2 as a dependency as it is necessary
    for llvm manifest tool (llvm-mt)
    (Closes: #990537)
    - not really working for now

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 17 Jul 2021 20:13:57 +0200

llvm-toolchain-11 (1:11.1.0-1~exp1) experimental; urgency=medium


