=== debian/tests/control ===
Test-Command: bash -v ./debian/qualify-clang.sh
Depends: @, cmake, make, g++, file, dpkg-dev, binfmt-support
# Comment the dbgsym package because of bug #917528
# dbgsym packages not being available in testing
# clang-14-dbgsym, libclang1-14-dbgsym
Restrictions: allow-stderr

Tests: integration-test-suite-test
Depends: @, cmake, make, g++, libstdc++-10-dev
Restrictions: allow-stderr

Tests: cmake-test
Depends: gcc, build-essential, cmake, llvm-14-dev, libclang-common-14-dev

Test-Command: python3 -c "import lldb; print(lldb.__file__); print(lldb)"
Depends: python3-lldb-14

Test-Command: python3 -c "import clang; print(clang.__file__); print(clang)"
Depends: python3-clang-14
